"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class HeritableTrait(ProtocolElement):
    """
    The entity representing a phenotype and its inheritance pattern.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_12 import reports as reports_6_4_0

        return {
            "inheritanceMode": reports_6_4_0.ModeOfInheritance,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_12 import reports as reports_6_4_0

        return {
            "org.gel.models.report.avro.ModeOfInheritance": reports_6_4_0.ModeOfInheritance,
            "org.gel.models.report.avro.HeritableTrait": reports_6_4_0.HeritableTrait,
        }

    __slots__ = [
        "inheritanceMode",
        "trait",
    ]

    def __init__(
        self,
        inheritanceMode=None,
        trait=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_4_0.HeritableTrait model.

        :param inheritanceMode:
            The mode of inheritance
        :type inheritanceMode: None | ModeOfInheritance
        :param trait:
            The trait (e.g.: HPO term, MIM term, DO term etc.)
        :type trait: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.4.0"
